<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from transform.texi on 28 April 1999 -->

<TITLE>The TRANSFORM Library - Simple Examples</TITLE>
<link href="transform_6.html" rel=Next>
<link href="transform_4.html" rel=Previous>
<link href="transform_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="transform_1.html">first</A>, <A HREF="transform_4.html">previous</A>, <A HREF="transform_6.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC5" HREF="transform_toc.html#TOC5">Simple Examples</A></H3>

<P>
Here we show a couple of simple examples to illustrate how to use tiling,
and what the resulting code looks like.
Given the following code (since tiling only changes the loop
bounds and not the body, we only show the bounds here):

</P>

<PRE>
for (i = 0; i &#60;= N; i++) {
    for (j = i; j &#60;= N; j++) {
        ...
    }
}
</PRE>

<P>
If we use the following parameters:

<PRE>
trip[0] = 100; trip[1] = 50;
nregions = 1;
coalesce[0] = FALSE;
first[0] = 0; first[1] = 2;
</PRE>

<P>
The resulting code is:

<PRE>
for (i_tile = 0; i_tile &#60;= N; i_tile += 100) {
    for (j_tile = i_tile; j_tile &#60;= N; j += 50) {
        for (i = i_tile; i &#60;= min(N, i_tile + 99); i++) {
            for (j = max(i, j_tile); j &#60;= min(i, j_tile + 49); j++) {
                ...
            }
        }
    }
}
</PRE>

<P>
If coalescing is turned on for the above example (setting coalesce[0] = TRUE),
the resulting code is:

</P>

<PRE>
for (j_tile = 0; j_tile &#60;= N; j_tile += 50) {
    for (i = 0; i &#60;= N; i++) {
        for (j = max(i, j_tile); j &#60;= min(i, j_tile + 49); j++) {
            ...
        }
    }
}
</PRE>

<P><HR><P>
<p>Go to the <A HREF="transform_1.html">first</A>, <A HREF="transform_4.html">previous</A>, <A HREF="transform_6.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
</BODY>
</HTML>
